Attribute VB_Name = "Miscellaneous"
Option Explicit

Public Declare Sub FillMem Lib "Kernel32.dll" _
Alias "RtlFillMemory" ( _
    pData As Any, _
    ByVal dwLen As Long, _
    ByVal Fill As Byte _
)

Public Declare Sub CpyMem Lib "Kernel32.dll" _
Alias "RtlMoveMemory" ( _
    pDst As Any, _
    pSrc As Any, _
    ByVal Length As Long _
)

Public Const INTEGER_BYTES  As Long = 2
Public Const LOG10          As Double = 2.30258509299405

Public Function FileExists(ByVal strFile As String) As Boolean
  Const NotFile = vbDirectory Or vbVolume

  On Error Resume Next
    FileExists = (GetAttr(strFile) And NotFile) = 0
  On Error GoTo 0
End Function

Public Function Minimum(ByVal l1 As Long, l2 As Long) As Long
    If l1 < l2 Then Minimum = l1 Else Minimum = l2
End Function

Public Function IsDirectory(ByVal strPath As String) As Boolean
    IsDirectory = (GetAttr(strPath) And vbDirectory)
End Function

Public Function AddSlash(ByVal strPath As String) As String
    If Right$(strPath, 1) <> "\" Then
        AddSlash = strPath & "\"
    Else
        AddSlash = strPath
    End If
End Function

Public Function IsRelativePath(ByVal strPath As String) As Boolean
    If Mid$(strPath, 2, 2) <> ":\" Then IsRelativePath = True
End Function

Public Function GetPath(ByVal strFile As String) As String
    If InStrRev(strFile, "\") > 0 Then
        GetPath = Left$(strFile, InStrRev(strFile, "\") - 1)
    Else
        GetPath = strFile
    End If
End Function

Public Function GetFileName(ByVal strFile As String) As String
    If InStrRev(strFile, "\") > 0 Then
        GetFileName = Mid$(strFile, InStrRev(strFile, "\") + 1)
    Else
        GetFileName = strFile
    End If
End Function

Public Function GetExtension(ByVal strFile As String) As String
    If InStr(strFile, ".") > 0 Then
        GetExtension = Mid$(strFile, InStrRev(strFile, ".") + 1)
    Else
        GetExtension = strFile
    End If
End Function

Public Function FormatMS(ByVal ms As Long) As String
    Dim lngSeconds As Long
    lngSeconds = ms \ 1000
    FormatMS = CStr(lngSeconds \ 60) & ":" & _
             Format(lngSeconds Mod 60, "00")
End Function
