Attribute VB_Name = "TimerManager"
Option Explicit


' Timer Verwaltung
'
' Verwendet wird der VB Timer, da keine groen Ansprche
' an Genauigkeit gestellt werden. Auerdem werden so
' keine Hacks verwendet, die das Debugging schwerer machen.


Public Declare Sub Sleep Lib "kernel32" ( _
    ByVal dwMS As Long _
)

Public Declare Function QueryPerformanceCounter Lib "kernel32" ( _
    x As Currency _
) As Boolean

Private m_lngTimerCount As Long
Private m_blnInit       As Boolean

Public Sub InitTimerManager()
    If Not m_blnInit Then
        Load TimerForm
        m_blnInit = True
    End If
End Sub

Public Sub DeinitTimerManager()
    If m_blnInit Then
        Unload TimerForm
        m_lngTimerCount = 0
        m_blnInit = False
    End If
End Sub

Public Function CreateNewTimer( _
    Optional ByVal interval As Long = 1000, _
    Optional ByVal enabled As Boolean = True _
) As Timer

    Dim objTmr As Timer
    Set objTmr = TimerForm.CreateTimer()
    
    With objTmr
        .interval = interval
        .enabled = enabled
    End With
    
    Set CreateNewTimer = objTmr
End Function

Public Sub DeleteTimer(ByVal tmr As Timer)
    TimerForm.DeleteTimer tmr
End Sub

Public Sub Wait(ByVal ms As Long)
    Dim curTimer As Currency
    Dim curNow As Currency
    
    QueryPerformanceCounter curTimer
    curTimer = curTimer + ms
    
    Do While curTimer > curNow
        QueryPerformanceCounter curNow
    Loop
End Sub
