VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ParserCodeBlock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IStatement

Private m_colStatements As Collection
Private m_colVars       As Collection

Public Property Get Statements() As Collection
    Set Statements = m_colStatements
End Property

Public Property Get Variables() As Collection
    Set Variables = m_colVars
End Property

Public Sub AddVariables(ByVal cls As ParserStatementDim)
    m_colVars.Add cls
End Sub

Public Sub AddStatement(ByVal cls As IStatement)
    m_colStatements.Add cls
End Sub

Private Sub Class_Initialize()
    Set m_colStatements = New Collection
    Set m_colVars = New Collection
End Sub

Private Sub IStatement_DeclareVars(ByVal ctx As TACContext)
    Dim clsSt   As IStatement
    Dim clsVar  As ParserStatementDim
    
    For Each clsSt In Statements
        On Error Resume Next
        Set clsVar = clsSt
        On Error GoTo 0
        
        If Not clsVar Is Nothing Then
            clsSt.DeclareVars ctx
        End If
    Next
End Sub

Private Sub IStatement_DestroyVars(ByVal ctx As TACContext)
    Dim clsSt   As IStatement
    Dim clsVar  As ParserStatementDim
    
    For Each clsSt In Statements
        clsSt.DestroyVars ctx
    Next
End Sub

Private Function IStatement_GenerateTAC(ByVal ctx As TACContext) As TACVar
    Dim clsSt   As IStatement
    
    For Each clsSt In Statements
        clsSt.GenerateTAC ctx
    Next
End Function
