VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ParserFunction"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IStatement

Private Type Parameter
    Name        As String
    DataType    As DATA_TYPE
    IsArray     As Boolean
    IsReference As Boolean
End Type

Public Name     As String
Public DataType As DATA_TYPE
Public Code     As ParserCodeBlock

Private m_udtParams()   As Parameter
Private m_lngParamCount As Long

Public Property Get ParamCount() As Long
    ParamCount = m_lngParamCount
End Property

Public Property Get ParamIsArray(ByVal i As Long) As Boolean
    ParamIsArray = m_udtParams(i).IsArray
End Property

Public Property Let ParamIsArray(ByVal i As Long, ByVal blnVal As Boolean)
    m_udtParams(i).IsArray = blnVal
End Property

Public Property Get ParamIsRef(ByVal i As Long) As Boolean
    ParamIsRef = m_udtParams(i).IsReference
End Property

Public Property Let ParamIsRef(ByVal i As Long, ByVal blnVal As Boolean)
    m_udtParams(i).IsReference = blnVal
End Property

Public Property Get ParamName(ByVal i As Long) As String
    ParamName = m_udtParams(i).Name
End Property

Public Property Let ParamName(ByVal i As Long, ByVal strVal As String)
    m_udtParams(i).Name = strVal
End Property

Public Property Get ParamType(ByVal i As Long) As DATA_TYPE
    ParamType = m_udtParams(i).DataType
End Property

Public Property Let ParamType(ByVal i As Long, ByVal udeType As DATA_TYPE)
    m_udtParams(i).DataType = udeType
End Property

Public Function AddParam( _
    ByVal strName As String, _
    ByVal udeType As DATA_TYPE, _
    ByVal blnArr As Boolean, _
    ByVal blnRef As Boolean _
) As Boolean

    Dim i As Long
    
    For i = 0 To ParamCount - 1
        If StrComp(ParamName(i), strName, vbTextCompare) = 0 Then
            Exit Function
        End If
    Next
    
    ReDim Preserve m_udtParams(m_lngParamCount)
    With m_udtParams(m_lngParamCount)
        .Name = strName
        .DataType = udeType
        .IsArray = blnArr
        .IsReference = blnRef
    End With
    m_lngParamCount = m_lngParamCount + 1
    
    AddParam = True
End Function

Private Sub IStatement_DeclareVars(ByVal ctx As TACContext)
    Dim i As Long
    Dim clsParam As TACVar
    
    For i = 0 To ParamCount - 1
        Set clsParam = CreateTACVar(TAC_PARAM, ParamName(i), , ParamType(i))
        ctx.AddCode CreateTAC(TAC_CMD_DECLARE, , , clsParam)
    Next
    
    ToIStatement(Code).DeclareVars ctx
End Sub

Private Sub IStatement_DestroyVars(ByVal ctx As TACContext)
    ToIStatement(Code).DestroyVars ctx
End Sub

Private Function IStatement_GenerateTAC(ByVal ctx As TACContext) As TACVar
    ctx.AddCode CreateTAC(TAC_CMD_ENTER, , "fnc_" & Name)
    IStatement_DeclareVars ctx
    ToIStatement(Code).GenerateTAC ctx
    ctx.AddCode CreateTAC(TAC_CMD_EXITLABEL, , EXIT_PREFIX & "fnc_" & Name)
    'ToIStatement(Code).DestroyVars ctx
    ctx.AddCode CreateTAC(TAC_CMD_LEAVE, , "fnc_" & Name)
End Function
