VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ParserStatementFor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IStatement

Public Counter      As ExpressionNode
Public ExprFrom     As ExpressionNode
Public ExprTo       As ExpressionNode
Public Code         As ParserCodeBlock

Private Sub IStatement_DeclareVars(ByVal ctx As TACContext)
    ToIStatement(Code).DeclareVars ctx
End Sub

Private Sub IStatement_DestroyVars(ByVal ctx As TACContext)
    ToIStatement(Code).DestroyVars ctx
End Sub

Private Function IStatement_GenerateTAC(ByVal ctx As TACContext) As TACVar
    Dim clsSt       As TACStatement
    Dim clsVarCnt   As TACVar
    Dim clsVarFrom  As TACVar
    Dim clsVarTo    As TACVar
    Dim clsVarIncr  As TACVar
    Dim strLblExit  As String
    Dim strLblRep   As String
    
    strLblExit = ctx.CreateLabel()
    strLblRep = ctx.CreateLabel()
    
    Set clsVarCnt = ToIStatement(Counter).GenerateTAC(ctx)
    Set clsVarFrom = ToIStatement(ExprFrom).GenerateTAC(ctx)
    Set clsVarTo = ToIStatement(ExprTo).GenerateTAC(ctx)
    Set clsVarIncr = CreateTACVar(TAC_VALUE, , 1, clsVarCnt.DataType)
    
    Set clsSt = CreateTAC(TAC_CMD_ASSIGN, NODE_OP_ASSIGN, , clsVarCnt, clsVarFrom)
    ctx.AddCode clsSt
    
    ctx.AddLabel strLblRep
    Set clsSt = CreateTAC(TAC_CMD_IF, NODE_OP_CMP_GRT, strLblExit, , clsVarCnt, clsVarTo)
    ctx.AddCode clsSt
    
    ToIStatement(Code).GenerateTAC ctx
    
    ctx.AddCode CreateTAC(TAC_CMD_ASSIGN, NODE_OP_ADD, , clsVarCnt, clsVarCnt, clsVarIncr)
    ctx.AddCode CreateTAC(TAC_CMD_JUMP, , strLblRep)
    ctx.AddLabel strLblExit
End Function
