VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ParserStatementIf"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IStatement

Public IfExpr   As ExpressionNode
Public IfCode   As ParserCodeBlock
Public ElseCode As ParserCodeBlock

Private Sub IStatement_DeclareVars(ByVal ctx As TACContext)
    ToIStatement(IfCode).DeclareVars ctx
    If Not ElseCode Is Nothing Then
        ToIStatement(ElseCode).DeclareVars ctx
    End If
End Sub

Private Sub IStatement_DestroyVars(ByVal ctx As TACContext)
    ToIStatement(IfCode).DestroyVars ctx
    If Not ElseCode Is Nothing Then
        ToIStatement(ElseCode).DestroyVars ctx
    End If
End Sub

Private Function IStatement_GenerateTAC(ByVal ctx As TACContext) As TACVar
    Dim clsIfVar As TACVar
    Dim strLblElse As String
    Dim strLblExit As String
    
    IStatement_DeclareVars ctx
    
    strLblElse = ctx.CreateLabel()
    If ElseCode Is Nothing Then
        strLblExit = strLblElse
    Else
        strLblExit = ctx.CreateLabel()
    End If

    Set clsIfVar = ToIStatement(IfExpr).GenerateTAC(ctx)
    ctx.AddCode CreateTAC(TAC_CMD_IFZ, , strLblElse, clsIfVar)
    ToIStatement(IfCode).GenerateTAC ctx
    
    If Not ElseCode Is Nothing Then
        ctx.AddCode CreateTAC(TAC_CMD_JUMP, , strLblExit)
        ctx.AddLabel strLblElse
        ToIStatement(ElseCode).GenerateTAC ctx
    End If
    
    ctx.AddLabel strLblExit
End Function
