VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DSPStudioPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IPlugin
Implements IPluginDSP

Private Const m_strDefaultCode As String = "Sub Main(sr As Int, ch As Int)" & vbCrLf & _
                                           "  # Globales Zeug initialisieren" & vbCrLf & _
                                           "End" & vbCrLf & _
                                           vbCrLf & _
                                           "Function DSP(x[] As Float, offset As Int, samples As Int) As Int" & vbCrLf & _
                                           "  Return samples" & vbCrLf & _
                                           "End"

Private m_clsSession    As Session
Private m_clsCodes      As Collection
Private m_blnInit       As Boolean

Public Property Get Codes() As Collection
    Set Codes = m_clsCodes
End Property

Public Sub RemoveCode(ByVal idx As Long)
    m_clsCodes.Remove idx
End Sub

Public Function CreateNewCode() As DSPStudioCode
    Dim cls As DSPStudioCode
    Set cls = New DSPStudioCode
    cls.Code = m_strDefaultCode
    cls.name = "DSP#" & (m_clsCodes.Count + 1)
    cls.Enabled = True
    cls.Valid = True
    If Not cls.Compiler.Compile(cls.Code) Then Err.Raise 1234, , "OH OH"
    m_clsCodes.Add cls, cls.name
    Set CreateNewCode = cls
End Function

Public Property Get MonoSession() As Session
    Set MonoSession = m_clsSession
End Property

Private Sub Class_Initialize()
    Set m_clsCodes = New Collection
End Sub

Private Property Get IPlugin_Description() As String
    IPlugin_Description = "Eigene DSPs schreiben"
End Property

Private Property Get IPlugin_Name() As String
    IPlugin_Name = "DSP Studio"
End Property

Private Property Get IPlugin_PluginType() As MonoPluginLib.PLUGIN_TYPE
    IPlugin_PluginType = PLUGIN_DSP
End Property

Private Sub IPluginDSP_FormatChanged(ByVal sr As Long, ByVal ch As Long)
    Dim cls As DSPStudioCode
    
    For Each cls In m_clsCodes
        If cls.Valid Then
            CallStd cls.Compiler.AddrOfMain, sr, ch
        End If
    Next
End Sub

Private Sub IPluginDSP_Init(ByVal mono As MonoPluginLib.Session)
    Set m_clsSession = mono
    CreateNewCode
End Sub

Private Sub IPluginDSP_ProcessSamples(samples() As Single, ByVal lngOffset As Long, ByVal lngSamples As Long, lngReturned As Long)
    Dim cls As DSPStudioCode
    
    lngReturned = lngSamples
    
    For Each cls In m_clsCodes
        If cls.Valid And cls.Enabled Then
            lngReturned = CallStd(cls.Compiler.AddrOfDSP, _
                                  VarPtr(samples(0)), _
                                  lngOffset, _
                                  lngReturned)
        End If
    Next
End Sub

Private Sub IPluginDSP_ShowConfig()
    DSPStudio.LoadMe Me
End Sub

Private Sub IPluginDSP_Terminate()
    '
End Sub

Private Sub IPluginDSP_TrackChanged()
    '
End Sub
