VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StreamWAV"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IPlugin
Implements IPluginStream

Private Const Extensions    As String = "wav"
Private Const Description   As String = "ACM Wave Audio"


Private Declare Function CreateFile Lib "Kernel32.dll" _
Alias "CreateFileA" ( _
    ByVal lpFileName As String, _
    ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, _
    lpSecurityAttributes As Any, _
    ByVal dwCreationDisposition As Long, _
    ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long _
) As Long

Private Declare Function ReadFile Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpBuffer As Any, _
    ByVal nNumberOfBytesToRead As Long, _
    lpNumberOfBytesRead As Long, _
    ByVal lpOverlapped As Any _
) As Long

Private Declare Function WriteFile Lib "kernel32" ( _
    ByVal hFile As Long, _
    lpBuffer As Any, _
    ByVal nNumberOfBytesToWrite As Long, _
    lpNumberOfBytesWritten As Long, _
    ByVal lpOverlapped As Any _
) As Long

Private Declare Function SetFilePointer Lib "kernel32" ( _
    ByVal hFile As Long, _
    ByVal lDistanceToMove As Long, _
    ByVal lpDistanceToMoveHigh As Long, _
    ByVal dwMoveMethod As Long _
) As Long

Private Declare Function GetFileSize Lib "kernel32" ( _
    ByVal hFile As Long, _
    ByVal lpFileSizeHigh As Long _
) As Long

Private Declare Function CloseHandle Lib "kernel32" ( _
    ByVal hObject As Long _
) As Long

Private Declare Sub ZeroMem Lib "kernel32" _
Alias "RtlZeroMemory" ( _
    pDst As Any, _
    ByVal dwLen As Long _
)

Private Declare Sub CpyMem Lib "kernel32" _
Alias "RtlMoveMemory" ( _
    pDst As Any, _
    pSrc As Any, _
    ByVal cb As Long _
)

Private Declare Function IsBadReadPtr Lib "kernel32" ( _
    ptr As Any, _
    ByVal ucb As Long _
) As Long

Private Declare Function IsBadWritePtr Lib "kernel32" ( _
    ptr As Any, _
    ByVal ucb As Long _
) As Long

Private Declare Function acmStreamPrepareHeader Lib "msacm32" ( _
    ByVal has As Long, _
    pash As ACMSTREAMHEADER, _
    ByVal fdwPrepare As Long _
) As Long

Private Declare Function acmStreamUnprepareHeader Lib "msacm32" ( _
    ByVal has As Long, _
    pash As ACMSTREAMHEADER, _
    ByVal fdwUnprepare As Long _
) As Long

Private Declare Function acmStreamOpen Lib "msacm32" ( _
    phas As Long, _
    ByVal had As Long, _
    pwfxSrc As Any, _
    pwfxDst As Any, _
    ByVal pwfltr As Long, _
    ByVal dwCallback As Long, _
    ByVal dwInstance As Long, _
    ByVal fdwOpen As Long _
) As Long

Private Declare Function acmStreamSize Lib "msacm32" ( _
    ByVal has As Long, _
    ByVal cbInput As Long, _
    pdwOutputBytes As Long, _
    ByVal fdwSize As Long _
) As Long

Private Declare Function acmStreamConvert Lib "msacm32" ( _
    ByVal has As Long, _
    pash As ACMSTREAMHEADER, _
    ByVal fdwConvert As Long _
) As Long

Private Declare Function acmStreamReset Lib "msacm32" ( _
    ByVal has As Long, _
    ByVal fdwReset As Long _
) As Long

Private Declare Function acmStreamClose Lib "msacm32" ( _
    ByVal has As Long, _
    ByVal fdwClose As Long _
) As Long

Private Declare Function mmioClose Lib "winmm" ( _
    ByVal hmmio As Long, _
    ByVal uFlags As Long _
) As Long

Private Declare Function mmioDescend Lib "winmm" ( _
    ByVal hmmio As Long, _
    lpck As MMCKINFO, _
    lpckParent As MMCKINFO, _
    ByVal uFlags As Long _
) As Long

Private Declare Function mmioDescendParent Lib "winmm" _
Alias "mmioDescend" ( _
    ByVal hmmio As Long, _
    lpck As MMCKINFO, _
    ByVal X As Long, _
    ByVal uFlags As Long _
) As Long

Private Declare Function mmioOpen Lib "winmm" _
Alias "mmioOpenA" ( _
    ByVal szFileName As String, _
    lpmmioinfo As MMIOINFO, _
    ByVal dwOpenFlags As Long _
) As Long

Private Declare Function mmioSeek Lib "winmm" ( _
    ByVal hmmio As Long, _
    ByVal lOffset As Long, _
    ByVal iOrigin As Long _
) As Long

Private Declare Function mmioStringToFOURCC Lib "winmm" _
Alias "mmioStringToFOURCCA" ( _
    ByVal sz As String, _
    ByVal uFlags As Long _
) As Long

Private Type ACMSTREAMHEADER
    cbStruct                    As Long
    fdwStatus                   As Long
    dwUser                      As Long
    pbSrc                       As Long
    cbSrcLength                 As Long
    cbSrcLengthUsed             As Long
    dwSrcUser                   As Long
    pbDst                       As Long
    cbDstLength                 As Long
    cbDstLengthUsed             As Long
    dwDstUser                   As Long
    dwReservedDriver(9)         As Long
End Type

Private Type MMIOINFO
   dwFlags                      As Long
   fccIOProc                    As Long
   pIOProc                      As Long
   wErrorRet                    As Long
   htask                        As Long
   cchBuffer                    As Long
   pchBuffer                    As String
   pchNext                      As String
   pchEndRead                   As String
   pchEndWrite                  As String
   lBufOffset                   As Long
   lDiskOffset                  As Long
   adwInfo(4)                   As Long
   dwReserved1                  As Long
   dwReserved2                  As Long
   hmmio                        As Long
End Type

Private Type WAVE_FORMAT
    wFormatTag                  As Integer
    wChannels                   As Integer
    dwSampleRate                As Long
    dwBytesPerSec               As Long
    wBlockAlign                 As Integer
    wBitsPerSample              As Integer
End Type

Private Type MMCKINFO
   ckid                         As Long
   ckSize                       As Long
   fccType                      As Long
   dwDataOffset                 As Long
   dwFlags                      As Long
End Type

Private Type CHUNKINFO
    Start                       As Long
    Length                      As Long
End Type

Private Type MMWAVEFORMATEX
    wFormatTag                  As Integer
    nChannels                   As Integer
    nSamplesPerSec              As Long
    nAvgBytesPerSec             As Long
    nBlockAlign                 As Integer
    wBitsPerSample              As Integer
    cbSize                      As Integer
End Type

Private Type hFile
    handle                      As Long
    path                        As String
End Type

Private Enum HACMSTREAM
    INVALID_STREAM_HANDLE = 0
End Enum

Private Enum ACM_STREAMSIZEF
    ACM_STREAMSIZEF_DESTINATION = &H1
    ACM_STREAMSIZEF_SOURCE = &H0
    ACM_STREAMSIZEF_QUERYMASK = &HF
End Enum

Private Enum ACM_STREAMCONVERTF
    ACM_STREAMCONVERTF_BLOCKALIGN = &H4
    ACM_STREAMCONVERTF_START = &H10
    ACM_STREAMCONVERTF_END = &H20
End Enum

Private Enum FILE_OPEN_METHOD
    CREATE_NEW = 1
    CREATE_ALWAYS = 2
    OPEN_EXISTING = 3
    OPEN_ALWAYS = 4
End Enum

Private Enum FILE_SHARE_RIGHTS
    FILE_SHARE_READ = &H1
    FILE_SHARE_WRITE = &H2
End Enum

Private Enum FILE_ACCESS_RIGHTS
    GENERIC_READ = &H80000000
    GENERIC_WRITE = &H40000000
End Enum

Private Enum SEEK_METHOD
    FILE_BEGIN = 0
    FILE_CURRENT = 1
    FILE_END = 2
End Enum

Public Enum SND_SEEK_MODE
    SND_SEEK_PERCENT
    SND_SEEK_SECONDS
End Enum

Private Const MMIO_READ         As Long = &H0
Private Const MMIO_FINDCHUNK    As Long = &H10
Private Const MMIO_FINDRIFF     As Long = &H20

Private Const INVALID_HANDLE    As Long = -1

Private Const SEEK_CUR          As Long = 1

Private Const WAVE_FORMAT_PCM   As Long = 1


' Stream

Private hFWave                  As hFile
Private cnkData                 As CHUNKINFO
Private cnkInfo                 As CHUNKINFO
Private udtWFXIn                As MMWAVEFORMATEX
Private udtWFXOut               As MMWAVEFORMATEX
Private btWFX()                 As Byte

' ACM

Private Const OUTPUT_BUFFER_MS  As Long = 500

Private hStream                 As HACMSTREAM

Private btInput()               As Byte
Private intOutput()             As Integer

Private Const BUF_SIZE          As Long = 4096
Private m_sngSamples(BUF_SIZE - 1) As Single
Private m_intSamples(BUF_SIZE - 1) As Integer
Private m_lngSampleCount        As Long
Private m_lngSamplesUsed        As Long

Private lngInputLen             As Long
Private lngOutputLen            As Long

Private lngPosInBuffer          As Long
Private lngBufferData           As Long

Private lngFilePositionMS       As Long

Private blnEndOfStream          As Boolean
Private blnFirst                As Boolean

Private lngKeepInBuffer         As Long

Private m_clsTags               As StreamTags

Private Sub Class_Initialize()
    hStream = INVALID_STREAM_HANDLE
    hFWave.handle = INVALID_HANDLE
    Set m_clsTags = New StreamTags
End Sub

Private Property Get IPlugin_Description() As String
    IPlugin_Description = "ffnet WAV Dateien"
End Property

Private Property Get IPlugin_Name() As String
    IPlugin_Name = "WAV Stream"
End Property

Private Property Get IPlugin_PluginType() As MonoPluginLib.PLUGIN_TYPE
    IPlugin_PluginType = PLUGIN_STREAM
End Property

Private Property Get IPluginStream_Channels() As Long
    IPluginStream_Channels = udtWFXIn.nChannels
End Property

Private Function IPluginStream_CreateNewStream() As MonoPluginLib.IPluginStream
    Set IPluginStream_CreateNewStream = New StreamWAV
End Function

Private Property Get IPluginStream_Description() As String
    IPluginStream_Description = Description
End Property

Private Property Get IPluginStream_Duration() As Long
    IPluginStream_Duration = (cnkData.Length) / udtWFXIn.nAvgBytesPerSec * 1000
End Property

Private Property Get IPluginStream_Extensions() As String()
    IPluginStream_Extensions = Split(Extensions, ";")
End Property

Private Property Get IPluginStream_Position() As Long
    IPluginStream_Position = lngFilePositionMS - OUTPUT_BUFFER_MS
End Property

Private Property Get IPluginStream_Samplerate() As Long
    IPluginStream_Samplerate = udtWFXIn.nSamplesPerSec
End Property

Private Function IPluginStream_StreamClose() As MonoPluginLib.STREAM_RESULT
    If hFWave.handle = INVALID_HANDLE Then
        IPluginStream_StreamClose = RESULT_UNKNOWN_ERROR
    Else
        CloseConverter
        FileClose hFWave
        lngFilePositionMS = 0
        IPluginStream_StreamClose = RESULT_SUCCESS
    End If
End Function

Private Property Get IPluginStream_StreamInfo() As MonoPluginLib.StreamTags
    Set IPluginStream_StreamInfo = m_clsTags
End Property

Private Function IPluginStream_StreamOpen(ByVal strPath As String) As MonoPluginLib.STREAM_RESULT
    IPluginStream_StreamClose

    ' "data" und "fmt " Chunks finden
    cnkData = GetWavChunkPos(strPath, "data")
    cnkInfo = GetWavChunkPos(strPath, "fmt ")

    ' gltige Chunks?
    If cnkData.Start = 0 Then
        IPluginStream_StreamOpen = RESULT_INVALID_FORMAT
        Exit Function
    End If

    If cnkInfo.Start = 0 Then
        IPluginStream_StreamOpen = RESULT_INVALID_FORMAT
        Exit Function
    End If

    If cnkInfo.Length < 16 Then
        IPluginStream_StreamOpen = RESULT_INVALID_FORMAT
        Exit Function
    End If

    hFWave = FileOpen(strPath, GENERIC_READ, FILE_SHARE_READ)

    If hFWave.handle = INVALID_HANDLE Then
        IPluginStream_StreamOpen = RESULT_CANT_OPEN
        Exit Function
    End If

    ' Data Chunk mit zu ungltig langer Lnge auf Dateilnge krzen
    If FileLength(hFWave) < (cnkData.Start + cnkData.Length) Then
        cnkData.Length = FileLength(hFWave) - cnkData.Start
    End If

    ' Info Chunk lesen
    ReDim btWFX(cnkInfo.Length - 1) As Byte
    FileSeek hFWave, cnkInfo.Start, FILE_BEGIN
    FileRead hFWave, VarPtr(btWFX(0)), cnkInfo.Length

    CpyMem udtWFXIn, btWFX(0), Len(udtWFXIn)

    FileSeek hFWave, cnkData.Start, FILE_BEGIN

    ' Audo Compression Manager starten
    If Not InitConversion(True) Then
        IPluginStream_StreamOpen = RESULT_UNKNOWN_ERROR
        IPluginStream_StreamClose
        Exit Function
    End If
    
    FillBuffer
    m_clsTags.AddInfo "samplerate", udtWFXIn.nSamplesPerSec
    m_clsTags.AddInfo "channels", udtWFXIn.nChannels
    m_clsTags.AddInfo "komprimiert", IIf(udtWFXIn.wFormatTag <> WAVE_FORMAT_PCM, "ja", "nein")
    
    IPluginStream_StreamOpen = RESULT_SUCCESS
End Function

Private Function GetWavChunkPos(ByVal strFile As String, ByVal strChunk As String) As CHUNKINFO
    Dim hMmioIn             As Long
    Dim lngRet              As Long
    Dim mmckinfoParentIn    As MMCKINFO
    Dim mmckinfoSubchunkIn  As MMCKINFO
    Dim mmioinf             As MMIOINFO

    hMmioIn = mmioOpen(strFile, mmioinf, MMIO_READ)
    If hMmioIn = 0 Then
        Exit Function
    End If

    mmckinfoParentIn.fccType = mmioStringToFOURCC("WAVE", 0)
    lngRet = mmioDescendParent(hMmioIn, _
                               mmckinfoParentIn, _
                               0, _
                               MMIO_FINDRIFF)

    If Not (lngRet = 0) Then
        mmioClose hMmioIn, 0
        Exit Function
    End If

    mmckinfoSubchunkIn.ckid = mmioStringToFOURCC(strChunk, 0)
    lngRet = mmioDescend(hMmioIn, _
                         mmckinfoSubchunkIn, _
                         mmckinfoParentIn, _
                         MMIO_FINDCHUNK)

    If Not (lngRet = 0) Then
        mmioClose hMmioIn, 0
        Exit Function
    End If

    GetWavChunkPos.Start = mmioSeek(hMmioIn, 0, SEEK_CUR)
    GetWavChunkPos.Length = mmckinfoSubchunkIn.ckSize

    mmioClose hMmioIn, 0
End Function

'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''

Private Function IsValidFile(ByVal strFile As String) As Boolean
    Dim hInp    As hFile

    hInp = FileOpen(strFile, GENERIC_READ, FILE_SHARE_READ)

    IsValidFile = hInp.handle <> INVALID_HANDLE
    FileClose hInp
End Function

Private Function FileOpen( _
    ByVal strFile As String, _
    Optional access As FILE_ACCESS_RIGHTS = GENERIC_READ Or GENERIC_WRITE, _
    Optional share As FILE_SHARE_RIGHTS = FILE_SHARE_READ Or FILE_SHARE_WRITE, _
    Optional method As FILE_OPEN_METHOD = OPEN_EXISTING _
) As hFile

    FileOpen.handle = CreateFile(strFile, access, share, ByVal 0&, method, 0, 0)
    FileOpen.path = strFile
End Function

Private Sub FileClose(filehandle As hFile)
    CloseHandle filehandle.handle
    filehandle.handle = INVALID_HANDLE
    filehandle.path = vbNullString
End Sub

Private Function FileRead(filehandle As hFile, ByVal ptr As Long, ByVal bytes As Long) As Long
    Dim dwRead  As Long
    Dim lngRet  As Long

    If filehandle.handle = INVALID_HANDLE Then
        Exit Function
    End If

    lngRet = ReadFile(filehandle.handle, ByVal ptr, bytes, dwRead, 0&)

    If lngRet = 1 Then
        FileRead = dwRead
    Else
        FileRead = -1
    End If
End Function

Private Function FileWrite(filehandle As hFile, ByVal ptr As Long, ByVal bytes As Long) As Long
    Dim dwWritten   As Long
    Dim lngRet      As Long

    If filehandle.handle = INVALID_HANDLE Then
        Exit Function
    End If

    lngRet = WriteFile(filehandle.handle, ByVal ptr, bytes, dwWritten, 0&)

    If lngRet = 1 Then
        FileWrite = dwWritten
    Else
        FileWrite = -1
    End If
End Function

Private Function FileSeek(filehandle As hFile, ByVal bytes As Long, ByVal method As SEEK_METHOD) As Long
    FileSeek = SetFilePointer(filehandle.handle, bytes, 0, method)
End Function

Private Function FilePosition(filehandle As hFile) As Long
    FilePosition = FileSeek(filehandle, 0, FILE_CURRENT)
End Function

Private Function FileLength(filehandle As hFile) As Long
    FileLength = GetFileSize(filehandle.handle, 0)
End Function

Private Function FileEnd(filehandle As hFile) As Boolean
    FileEnd = FilePosition(filehandle) >= FileLength(filehandle)
End Function

Private Function IPluginStream_StreamRead(sngBuffer() As Single, ByVal lngOffset As Long, ByVal lngSamples As Long, lngSamplesRead As Long) As MonoPluginLib.STREAM_RESULT
    Dim lngNeeded As Long
    
    IPluginStream_StreamRead = RESULT_SUCCESS
    lngSamplesRead = 0
    
    If m_lngSampleCount = 0 Then
        If blnEndOfStream Then
            IPluginStream_StreamRead = RESULT_END_OF_STREAM
        Else
            IPluginStream_StreamRead = RESULT_READ_ERROR
        End If
        Exit Function
    End If
    
    Do
        lngNeeded = Minimum(lngSamples, m_lngSampleCount - m_lngSamplesUsed)
        CpyMem sngBuffer(lngOffset + lngSamplesRead), m_sngSamples(m_lngSamplesUsed), 4 * lngNeeded
        lngSamples = lngSamples - lngNeeded
        m_lngSamplesUsed = m_lngSamplesUsed + lngNeeded
        lngSamplesRead = lngSamplesRead + lngNeeded
        
        If m_lngSamplesUsed = m_lngSampleCount Then
            Select Case FillBuffer()
                Case RESULT_SUCCESS
                    ' nichts tun
                Case RESULT_END_OF_STREAM
                    If m_lngSampleCount = 0 Then
                        IPluginStream_StreamRead = RESULT_END_OF_STREAM
                    End If
                Case Else
                    IPluginStream_StreamRead = RESULT_READ_ERROR
            End Select
        End If
    Loop While (lngSamples > 0) And (Not blnEndOfStream)
End Function

Private Function IPluginStream_StreamSeek(ByVal ms As Long) As MonoPluginLib.STREAM_RESULT
    Dim lngBytes    As Long

    If hFWave.handle = INVALID_HANDLE Then
        IPluginStream_StreamSeek = RESULT_CANT_OPEN
        Exit Function
    End If

    If ms < 0 Then ms = 0
    If ms > IPluginStream_Duration Then ms = IPluginStream_Duration

    lngBytes = udtWFXIn.nAvgBytesPerSec * (ms / 1000)

    If ms = 0 Then
        FileSeek hFWave, cnkData.Start, FILE_BEGIN
    Else
        lngBytes = AlignBytes(lngBytes) + cnkData.Start
        FileSeek hFWave, lngBytes, FILE_BEGIN
    End If

    ' ACM Stream reseten, um Puffer des Codecs zu leeren
    lngFilePositionMS = (FilePosition(hFWave) - cnkData.Start) / udtWFXIn.nAvgBytesPerSec * 1000
    ResetConverter
    
    IPluginStream_StreamSeek = RESULT_SUCCESS
End Function

Private Function AlignBytes(ByVal bytes As Long) As Long
    AlignBytes = bytes - (bytes Mod udtWFXIn.nBlockAlign)
End Function

Private Function CreateWFX(sr As Long, chs As Integer, bps As Integer) As MMWAVEFORMATEX
    With CreateWFX
        .wFormatTag = WAVE_FORMAT_PCM
        .nChannels = chs
        .nSamplesPerSec = sr
        .wBitsPerSample = bps
        .nBlockAlign = chs * (bps / 8)
        .nAvgBytesPerSec = sr * .nBlockAlign
    End With
End Function

Private Function InitConversion(Optional Force16Bit As Boolean = False) As Boolean
    Dim mmr     As Long

    If hStream <> INVALID_STREAM_HANDLE Then
        CloseConverter
    End If

    udtWFXOut = udtWFXIn

    If udtWFXOut.wBitsPerSample < 8 Then
        udtWFXOut.wBitsPerSample = 8
    ElseIf udtWFXOut.wBitsPerSample > 8 Then
        udtWFXOut.wBitsPerSample = 16
    End If

    If Force16Bit Then udtWFXOut.wBitsPerSample = 16

    With udtWFXOut
        udtWFXOut = CreateWFX(.nSamplesPerSec, _
                              .nChannels, _
                              .wBitsPerSample)
    End With

    mmr = acmStreamOpen(hStream, 0, _
                        btWFX(0), udtWFXOut, _
                        0, 0, 0, 0)

    If mmr <> 0 Then
        If Force16Bit Then Exit Function

        If udtWFXOut.wBitsPerSample = 16 Then
            udtWFXOut.wBitsPerSample = 8
        Else
            udtWFXOut.wBitsPerSample = 16
        End If

        mmr = acmStreamOpen(hStream, 0, _
                            btWFX(0), udtWFXOut, _
                            0, 0, 0, 0)

        If mmr <> 0 Then Exit Function
    End If

    ' Gre des Output Puffers
    lngOutputLen = OUTPUT_BUFFER_MS / 1000 * udtWFXOut.nAvgBytesPerSec

    ' Fr Output Puffer ntige Gre des Input Puffers
    mmr = acmStreamSize(hStream, _
                        lngOutputLen, _
                        lngInputLen, _
                        ACM_STREAMSIZEF_DESTINATION)

    If mmr <> 0 Then
        acmStreamClose hStream, 0
        hStream = 0
        Exit Function
    End If

    ReDim intOutput(lngOutputLen / 2 - 1) As Integer
    ReDim btInput(lngInputLen - 1) As Byte

    blnEndOfStream = False
    blnFirst = True

    lngKeepInBuffer = 0

    InitConversion = True
End Function

Private Function Convert( _
    ByVal lngInLen As Long, ByVal lngOutLen As Long, _
    lngInUsed As Long, lngOutUsed As Long, _
    Optional ByVal LastConversion As Boolean = False _
) As Boolean

    Dim lngFlags    As Long
    Dim udtHdr      As ACMSTREAMHEADER

    lngFlags = ACM_STREAMCONVERTF_BLOCKALIGN

    If blnFirst Then _
        lngFlags = lngFlags Or ACM_STREAMCONVERTF_START
    If LastConversion Then _
        lngFlags = lngFlags Or ACM_STREAMCONVERTF_END

    With udtHdr
        .cbStruct = Len(udtHdr)
        .cbSrcLength = lngInLen
        .cbDstLength = lngOutLen
        .pbDst = VarPtr(intOutput(0))
        .pbSrc = VarPtr(btInput(0))
    End With

    acmStreamPrepareHeader hStream, udtHdr, 0

    blnFirst = False

    If 0 = acmStreamConvert(hStream, udtHdr, lngFlags) Then
        With udtHdr
            lngInUsed = .cbSrcLengthUsed
            lngOutUsed = .cbDstLengthUsed

            lngKeepInBuffer = .cbSrcLength - .cbSrcLengthUsed
        End With

        If lngKeepInBuffer > 0 Then
            ' Codec hat nicht alle Input Bytes verbraucht,
            ' diese fr die nchste Blockkonvertierung aufbewahren
            CpyMem btInput(0), _
                   btInput(lngInLen - lngKeepInBuffer), _
                   lngKeepInBuffer
        End If

        Convert = True
    End If

    acmStreamUnprepareHeader hStream, udtHdr, 0
End Function

Private Function StreamRead(ByVal buffer_ptr As Long, ByVal buffer_len As Long, ByRef buffer_read As Long) As STREAM_RESULT
    StreamRead = RESULT_SUCCESS

    buffer_read = 0

    Do While buffer_read < buffer_len

        ' PCM Puffer leer
        If lngBufferData = 0 Then
            If FillBufferACM() <> RESULT_SUCCESS Then
                StreamRead = RESULT_END_OF_STREAM
                Exit Do
            End If

        ' nicht genug Daten im PCM Puffer
        ElseIf (lngBufferData - lngPosInBuffer) < (buffer_len - buffer_read) Then
            If 0 < (lngBufferData - lngPosInBuffer) Then

                If 0 = IsBadReadPtr(ByVal VarPtr(intOutput(0)) + lngPosInBuffer, _
                                    lngBufferData - lngPosInBuffer) Then

                    If 0 = IsBadWritePtr(ByVal buffer_ptr + buffer_read, _
                                         lngBufferData - lngPosInBuffer) Then

                        CpyMem ByVal buffer_ptr + buffer_read, _
                               ByVal VarPtr(intOutput(0)) + lngPosInBuffer, _
                               lngBufferData - lngPosInBuffer

                    End If

                End If

                buffer_read = buffer_read + (lngBufferData - lngPosInBuffer)
            End If

            If FillBufferACM() <> RESULT_SUCCESS Then
                StreamRead = RESULT_END_OF_STREAM
                Exit Do
            End If

        ' genug Daten im PCM Puffer
        Else
            If 0 = IsBadReadPtr(ByVal VarPtr(intOutput(0)) + lngPosInBuffer, _
                                buffer_len - buffer_read) Then

                If 0 = IsBadWritePtr(ByVal buffer_ptr + buffer_read, _
                                     buffer_len - buffer_read) Then

                    CpyMem ByVal buffer_ptr + buffer_read, _
                           ByVal VarPtr(intOutput(0)) + lngPosInBuffer, _
                           buffer_len - buffer_read

                End If

            End If

            lngPosInBuffer = lngPosInBuffer + (buffer_len - buffer_read)
            buffer_read = buffer_read + (buffer_len - buffer_read)

        End If

    Loop
    
    lngFilePositionMS = lngFilePositionMS + (buffer_read / udtWFXOut.nAvgBytesPerSec * 1000)
End Function

Private Function ReadWAVData(ByVal data_ptr As Long, ByVal data_len As Long, data_read As Long) As STREAM_RESULT
    ReadWAVData = RESULT_SUCCESS

    If hFWave.handle = INVALID_HANDLE Then
        ReadWAVData = RESULT_CANT_OPEN
        Exit Function
    End If

    If FilePosition(hFWave) > (cnkData.Start + cnkData.Length) Then
        ReadWAVData = RESULT_END_OF_STREAM
        data_read = 0
        Exit Function
    End If

    If FilePosition(hFWave) + data_len > (cnkData.Start + cnkData.Length) Then
        ' beinahe am Ende der Datei angekommen,
        ' nach diesem Lesevorgang aber vollends da
        data_len = (cnkData.Start + cnkData.Length) - FilePosition(hFWave)
        ReadWAVData = RESULT_END_OF_STREAM
    End If

    data_read = FileRead(hFWave, data_ptr, data_len)
End Function

Private Function FillBuffer() As STREAM_RESULT
    Dim lngWritten As Long
    Dim i As Long
    
    FillBuffer = StreamRead(VarPtr(m_intSamples(0)), BUF_SIZE * 2, lngWritten)
    
    m_lngSampleCount = lngWritten \ 2
    m_lngSamplesUsed = 0
    For i = 0 To m_lngSampleCount - 1
        m_sngSamples(i) = m_intSamples(i) / 32768
    Next
End Function

Private Function FillBufferACM() As STREAM_RESULT
    Dim lngRead     As Long
    Dim lngWritten  As Long
    Dim udeRet      As STREAM_RESULT
    Dim i           As Long

    If blnEndOfStream Then
        FillBufferACM = RESULT_END_OF_STREAM
        Exit Function
    End If

    udeRet = ReadWAVData(VarPtr(btInput(lngKeepInBuffer)), _
                         lngInputLen - lngKeepInBuffer, _
                         lngRead)

    If udeRet <> RESULT_SUCCESS Then
        If udeRet <> RESULT_END_OF_STREAM Then
            blnEndOfStream = True
        Else
            If lngRead = 0 Then blnEndOfStream = True
        End If
    End If

    Convert lngRead + lngKeepInBuffer, _
            lngOutputLen, _
            lngRead, lngWritten, _
            blnEndOfStream

    lngPosInBuffer = 0
    lngBufferData = lngWritten

    FillBufferACM = RESULT_SUCCESS
End Function

Private Sub ResetConverter()
    If hStream = INVALID_STREAM_HANDLE Then Exit Sub

    CloseConverter

    acmStreamOpen hStream, 0, btWFX(0), udtWFXOut, 0, 0, 0, 0
    lngOutputLen = OUTPUT_BUFFER_MS / 1000 * udtWFXOut.nAvgBytesPerSec
    acmStreamSize hStream, lngOutputLen, lngInputLen, ACM_STREAMSIZEF_DESTINATION

    ReDim intOutput(lngOutputLen / 2 - 1) As Integer
    ReDim btInput(lngInputLen - 1) As Byte

    blnEndOfStream = False
    blnFirst = True

    lngKeepInBuffer = 0
End Sub

Private Function CloseConverter() As Boolean
    acmStreamClose hStream, 0
    hStream = INVALID_STREAM_HANDLE

    ZeroMem btInput(0), lngInputLen
    ZeroMem intOutput(0), lngOutputLen

    blnEndOfStream = False
    lngBufferData = 0
    lngPosInBuffer = 0
    lngInputLen = 0
    lngOutputLen = 0
    lngKeepInBuffer = 0

    CloseConverter = True
End Function
